%%
% This code computes the sensitivity, specificity, AUC, AULC and AULCratio values
% Before running this code, you need install Matlab
% In our experiment, Matlab R2014a 64bit is tested
%%

clear all;
clc;

%% Load data
DATA=load('nonredundant/PROprednonredundant.txt');
[dataRow,dataCol]=size(DATA);

%% Positive Samples
positiveIndex=find(DATA(:,1)==1);
[positiveRow,positiveCol]=size(positiveIndex);
positiveSamples=zeros(positiveRow,2);

for i=1:positiveRow
   positiveSamples(i,:)=DATA(positiveIndex(i,1),:);    
end

%% Negative Samples
negativeIndex=find(DATA(:,1)==0);
[negativeRow,negativeCol]=size(negativeIndex);
negativeSamples=zeros(negativeRow,2);

for i=1:negativeRow
   negativeSamples(i,:)=DATA(negativeIndex(i,1),:);    
end

%% Random pick from negative samples

RandPickNegSamples=zeros(positiveRow,2);
RandIndex=randperm(negativeRow);
for j=1:positiveRow
    RandPickNegSamples(j,:)=negativeSamples(RandIndex(j),:);
end

tempCombinedPosNegSamples=[positiveSamples;RandPickNegSamples];


r=randperm(size(tempCombinedPosNegSamples,1));
CombinedPosNegSamples=tempCombinedPosNegSamples(r, :);

label=CombinedPosNegSamples(:,1);
bybridNAP=CombinedPosNegSamples(:,2);

[AUCBindN,sensBindN,speBindN]=area_under_roc(bybridNAP,label);

calspeBindN=1.-speBindN;

for i=1:size(calspeBindN)-1
    if(calspeBindN(i,1)<0.05)
        SNthresholdBindN=sensBindN(i,1);
        break;
    end
end

AULCBindN=0;
for i=1:size(calspeBindN)-1
    if(calspeBindN(i,1)<0.05 & calspeBindN(i,1)>0)
        AULCBindN=AULCBindN + (sensBindN(i,1)+sensBindN(i+1,1))/2*(calspeBindN(i,1)-calspeBindN(i+1,1));  
    end
end

AULCratioBindN=AULCBindN/(0.05*0.05*0.5);

SNthresholdBindN
AUCBindN
AULCratioBindN
